// Copyright (C) 1996 DIMACS Center, Rutgers, The State University of New Jersey
// Author(s): Jonathan Berry

// This software is copyrighted by the DIMACS Center at Rutgers, The State
// University of New Jersey.  IT IS PROVIDED AS IS, AND THE AUTHORS, DIMACS, AND
// RUTGERS, THE STATE UNIVERSITY OF NEW JERSEY  DISCLAIM
// ALL LIABILITY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL
// DAMAGES ARISING OUT OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY
// DERIVATIVES THEREOF, EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.

// THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES,
// INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  THIS SOFTWARE
// IS PROVIDED ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE
// NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
// MODIFICATIONS.

// The authors hereby grant permission to use, copy, modify, distribute,
// and license this software and its documentation for any purpose, provided
// that existing copyright notices are retained in all copies and that this
// notice is included verbatim in any distributions. No written agreement,
// license, or royalty fee is required for any of the authorized uses.
// Modifications to this software may be copyrighted by their authors
// and need not follow the licensing terms described here, provided that
// the new terms are clearly indicated on the first page of each file where
// they apply.

// Last File Update: 31-Jul-1996
// 

#ifndef BinGraph_h
#define BinGraph_h

#include <LINK/graph/HyperGraph.h>

class Edge;


class MBinGraph : public MHyperGraph {
protected:

    Edge*		addEdge(Edge *e);

public:

    MBinGraph() {}
    MBinGraph(const Graph &G, Flag clone=CLONE, Flag reverse=0, 
		Flag new_edgetype=MIXED, Flag new_simple=MULTI) 
			: MHyperGraph(G, clone, reverse,
				new_edgetype, new_simple, BIN) {}
    MBinGraph(const MBinGraph &G, Flag clone=CLONE, Flag reverse=0, 
		Flag new_edgetype=MIXED, Flag new_simple=MULTI) 
			: MHyperGraph(G, clone, reverse,
				new_edgetype, new_simple, BIN) {}

			// managing subgraphs
    Graph*              newGraph() { return (Graph*) new MBinGraph; }
    Graph*              copyGraph(Flag clone = CLONE, Flag reverse=0) 
			{ return (Graph*) new MBinGraph(*this, clone,reverse); }

			// override for edges of size 2
    Edge*		addEdge(Collection<Vertex*>& vs, String n=0);
    Edge*		addEdge(Sequence<Vertex*> vs, String n=0);
    void		deleteVertex(Vertex* passed_vertex);

    DataType		type() const	{ return M_MIXEDBINARYGRAPH; }


    MBinGraph		complement() const;
    MBinGraph		lineGraph() const;
    MBinGraph		sum(const Graph& g) const;
    MBinGraph		intersection(const Graph& g) const;
    MBinGraph		product(const Graph& g) const;
    MBinGraph		lexicographicProduct(const Graph& g) const;
    MBinGraph		operator+(const Graph& g) const;
    MBinGraph		operator*(const Graph& g) const;

};

class BinGraph : public MBinGraph {
public:
    BinGraph() {}
    BinGraph(const Graph &G, Flag clone=CLONE, Flag reverse=0) 
				: MBinGraph(G, clone, reverse, MIXED,SIMPLE) {}
    BinGraph(const BinGraph &G, Flag clone=CLONE, Flag reverse=0) 
				: MBinGraph(G, clone, reverse, MIXED,SIMPLE) {}
    Graph*              newGraph() { return (Graph*) new BinGraph; }
    Graph*              copyGraph(Flag clone = CLONE, Flag reverse=0) 
			{ return (Graph*) new BinGraph(*this, clone,reverse); }
    Edge*	addEdge(Collection<Vertex*>& vs, String n=0)
		    { return isEdge(vs)? (Edge*)0: MBinGraph::addEdge(vs, n); }
    Edge*	addEdge(Sequence<Vertex*> vs, String n=0)
		    { return isEdge(vs)? (Edge*)0: MBinGraph::addEdge(vs, n); }
    DataType	type() const	{ return MIXEDBINARYGRAPH; }
};


#endif
